% TP5 S5 2023-2024 Probabilites : Lois usuelles - Convergence de suites de variables aleatoires
% les histogrammes seront traces avec la fonction tracehist(x) definie a la fin du script
% 
clf;
disp('1- Simulations et histogrammes de lois usuelles');
disp('2- Loi des grands nombres, convergence presque sre, convergence en probabilit');
disp('3- Thorme central limite, convergence en loi');
choix = input('Choix = ');
switch choix
    case 1 %Simulations et histogrammes de lois usuelles
        disp('1- loi uniforme U(0,1)');
        disp('2- loi binomiale B(n,p)');
        disp('3- loi exponentielle E(lambda)');
        disp('4- loi de Poisson P(lambda)');
        disp('5- loi normale N(m,v)');
        choix1 = input('Choix = ');
        N = input('Nombre de ralisations N = ');   
        switch choix1
			case 1 % loi uniforme U(0,1)
                disp('simulation et histogramme d''une v.a. continue de loi uniforme sur [0,1]');
				titre = ['simulation de ',int2str(N),' valeurs d''une v.a. de loi uniforme U(0,1)'];
                x = rand(1,N);                
            case 2 % loi binomiale B(n,p)
                disp('simulation et histogramme d''une v.a. de loi binomiale B(n,p)');
                n = input('n = '); p = input('p = ');
				titre = ['simulation de ',int2str(N),' valeurs d''une v.a. de loi binomiale B(',int2str(n),' ; ',num2str(p),')'];
                x = binomiale(N,n,p);
            case 3 % loi exponentielle E(lambda)
                disp('simulation et histogramme d''une v.a. de loi exponentielle E(lambda)');
                lambda = input('lambda = ');
				titre = ['simulation de ',int2str(N),' valeurs d''une v.a. de loi exponentielle E(',num2str(lambda),')'];
                x = exponentielle(N,lambda);
            case 4 % loi de Poisson P(lambda)
                disp('simulation et histogramme d''une v.a. de loi de Poisson P(lambda)');
                lambda = input('lambda = ');
				titre = ['simulation de ',int2str(N),' valeurs d''une v.a. de loi de Poisson P(',num2str(lambda),')'];
                x = poissrnd(lambda,1,N);
            case 5 % loi normale N(m,v)
                disp('simulation et histogramme d''une v.a. de loi normale N(m,v)');
                m = input('m = '); v = input('v = ');
				titre = ['simulation de ',int2str(N),' valeurs d''une v.a. de loi normale N(',num2str(m),' ; ',num2str(v),')'];
                x = normale(N,m,v);
        end
        % graphes
		subplot(2,1,1); plot(1:N,x,'+');
        title(titre);
        subplot(2,1,2); tracehist(x); % fonction tracehist donnee a la fin du script
        title('histogramme associ');
    case 2 % Loi des grands nombres, convergence presque sre, convergence en probabilit
        disp('1- Loi des grands nombres');
        disp('2- Exemples de convergence en probabilit avec ou sans convergence p.s.');
        choix2 = input('Choix = ');
        switch choix2
            case 1 % Loi des grands nombres
                disp('Illustration de loi forte des grands nombres');
                disp('1- pour la loi uniforme');
                disp('2- pour une loi de Poisson');
                choix21 = input('Choix = ');
				nmax = input('On calcule xnbar jusqu'' nmax = ');n = (1:nmax);
                switch choix21
                    case 1
                        disp('Avec la loi uniforme');
                        titre = ['Valeurs xnbar de la suite (Xnbar), n = 1, ..., ',int2str(nmax),' pour la loi uniforme'];
                        title(titre);
                        % calcul des valeurs xnbar pour n de 1  nmax
                        for i = 1:9
                            subplot(3,3,i)
                            x = rand(1,nmax);
                            xbar = cumsum(x) ./ (1:nmax);
                            % affichage de la dernire valeur calculee
                            disp(xbar(nmax));
                            % graphe des (n,xnbar) avec titre en title 
                            plot(1:nmax, xbar);
                        end
                    case 2
                        disp('Avec une loi de Poisson P(lambda)');
                        lambda = input('lambda = ');
                        titre = ['Valeurs xnbar de la suite (Xnbar), n = 1, ..., ',int2str(nmax),' pour la loi de Poisson P(',num2str(lambda),')'];

                        % calcul des valeurs xnbar pour n de 1  nmax
                        for i = 1:9
                            subplot(3,3,i)
                            x = poissrnd(lambda, 1,nmax);
                            xbar = cumsum(x) ./ (1:nmax);
                            % affichage de la dernire valeur calculee
                            disp(xbar(nmax));
                            % graphe des (n,xnbar) avec titre en title 
                            plot(1:nmax, xbar);
                        end
                end
				
            case 2 % Exemples de convergence en probabilit avec ou sans convergence p.s.
                disp('Simulation d''une suite de v.a. Xn qui converge en probabilit avec ou sans convergence p.s.');
                disp('1- Xn telle que P(Xn=n)=p=1/racine(n) et P(Xn=0)=1-p');
                disp('2- Xn telle que P(Xn=n)=1/n^2 et P(Xn=0)=1-p');
                choix22 = input('Choix = ');
                nmax = input('On calcule xn jusqu'' nmax = ');
                switch choix22
                    case 1 % p=1/racine(n)
                        x = (rand(1,nmax) < 1 ./ sqrt(1:nmax)) .* (1:nmax);
                        % calcul des valeurs xn pour n de 1  nmax
                        plot(1:nmax,x);
                        % graphe des (n,xnbar) 
						% COMPLETER
                        title(['Valeurs xn de la suite (Xn), n = 1, ..., ',int2str(nmax),' avec p=1/racine(n)']);
                    case 2 % p=1/(n^2)
                        % calcul des valeurs xn pour n de 1  nmax
                        x = (rand(1,nmax) < 1 ./ (1:nmax) .^ 2) .* (1:nmax);
                        % calcul des valeurs xn pour n de 1  nmax
                        plot(1:nmax,x);
                        % graphe des (n,xnbar) 
						% COMPLETER
                        title(['Valeurs xn de la suite (Xn), n = 1, ..., ',int2str(nmax),' avec p=1/(n^2)']);
                end
        end
    case 3 % Thorme central limite, convergence en loi
        disp('1- Convergence en loi du Theoreme Central Limite');
        disp('2- Approximation d''une loi binomiale vers une loi de Poisson');
        disp('3- Approximation d''une loi binomiale vers une loi normale');
        disp('4- Approximation d''une loi de Poisson vers une loi normale');
        choix3 = input('Choix = ');
        switch choix3
            case 1 % Convergence en loi du Theoreme Central Limite
                disp('1- avec la loi uniforme');
                disp('2- avec une loi de Poisson');
                choix31 = input('Choix = ');
                switch choix31
                    case 1
                        disp('Illustration du theoreme central limite avec la loi uniforme');
                        x = rand(N,nmax);
                        xbar = sum(x) ./ nmax;
                        z = (xbar - 0.5) .* 2 .* sqrt(3) .* sqrt(nmax);
                        tracehist(z);
                    case 2
                        disp('Illustration du theoreme central limite avec une loi de Poisson P(lambda = 3)');
                        lambda = 3;
                        x = poissrnd(lambda,N,nmax);
                        xbar = sum(x) ./ nmax;
                        z = (xbar - lambda) ./ (lambda / sqrt(nmax));
                        tracehist(z);
                end
				
            case 2 % Approximation d''une loi binomiale vers une loi de Poisson
                disp('Approximation d''une loi B(n,p) par la loi P(np) pour n > 50 et np < 18');
                n = 100;
                p = 0.10;
                xp = poissrnd(n * p, 1, N);
                xb = binomiale(N, n, p);
                hold on
                tracehist(xp)
                tracehist(xb)
            case 3 % Approximation d''une loi binomiale vers une loi normale
                disp('Approximation d''une loi B(n,p) par la loi normale N(np,npq) pour n > 50 et np > 18');
                n = 100;
                p = 0.30;
                q = 1 - p;
                xn = randn(1,N) * sqrt(n * p * q) + n * p;
                xb = binomiale(N, n, p);
                hold on
                tracehist(xn)
                tracehist(xb)
            case 4 % Approximation d''une loi de Poisson vers une loi normale
                disp('Approximation d''une loi de Poisson P(lambda) par la loi normale N(lambda,lambda) pour lambda > 18');
                lambda = 30;
                xn = randn(1,N) * sqrt(lambda) + lambda;
                xp = poissrnd(lambda, 1, N);
                hold on
                tracehist(xn)
                tracehist(xp)
        end
end

function tracehist(x)
    [nelements,centers] = hist(x);
    h = centers(2)-centers(1); N = length(x);
    hauteurs = nelements/(N*h);
    bar(centers, hauteurs);
end
